<template>
    <div>
        <div class="mt-3">
            <div v-for="post,index in postsToShow" :key="post.id" class="card bg-post my-3" id="post-box">

                <div id="post-header" class="d-flex justify-content-between align-items-center">
                    <div id="author" class="d-flex">
                        <img v-bind:src="post.User.image" id="user-img" v-bind:alt='"Photo de profil de " + post.User.firstname + " " + post.User.lastname'>
                        <div class="align-self-center">
                            <p id="user-name" class="text-start my-0">{{ post.User.firstname }}
                                {{ post.User.lastname }}</p>
                            <p id="post-created-at" class="text-start my-0 very-small-font">le
                                {{formattedDate(post)}}</p> 
                        </div>
                    </div>
                    <!--  -->
                    <div id="edit-delete-icons" class="mx-2 my-2" v-if="!isEditOpen || !isDeleteOpen">
                        <button class="btn-modify align-middle" @click="editPost(post)" v-if="post.UserId === currentUserId && !isEditOpen" aria-label="Editer le Post">
                            <i class="fas fa-edit"></i>
                        </button>
                        <button class="btn-modify align-middle" @click="deletePost(post)" v-if="canEdit(post) && !isDeleteOpen" aria-label="Supprimer le Post">
                            <i class="fas fa-trash-alt"></i>
                        </button>
                        <!-- <edit-modale v-if="modaleEdit && postIndex == index"></edit-modale> -->
                    </div>
                </div>
                <div class="bg-dark ">
                    <img v-if="post.image !== ''" v-bind:src="post.image" :alt="'Image du post ' + (index + 1)">
                </div>
                    <p class="card-title text-start mx-2 my-2">{{post.title}}</p>
                    <p class="text-start mx-2 little-font"> {{post.content}} </p>
                <div class="edit-post card px-5" v-if="isEditOpen && postIndex == index">
                    <input type="text" v-model="form.title">
                    <textarea placeholder="Nouveau message..." v-model="form.content" class="mt-2"></textarea>
                    <label for="file-upload" class="custom-file-upload text-left mt-2">Changer l'image</label>
                    <p class="cuted-text" v-if="selectedFile !== ''"> {{selectedFile}} </p>
                    <input id="file-upload" type="file" v-on:change="onFileSelected">
                    <button class="btn btn-danger btn-edit-post mb-2" @click="sendEditPost(post)">Enregistrer les changements</button>  
                </div>
                <div v-if="isDeleteOpen && postIndex == index" class="mb-2">
                    <p>Etes-vous sûr de vouloir supprimer ce post?</p>
                    <button class="btn btn-danger mx-3 px-1 py-0" @click="sendDeletePost(post)">Oui</button>
                    <button class="btn btn-connexion mx-3 px-1 py-0 text-light" @click="isDeleteOpen=false">Non</button>
                </div>
                <comments-container v-if="!isDeleteOpen" :PostId="post.id"></comments-container>
                <create-comment v-if="!isDeleteOpen" :PostId="post.id"></create-comment>

            </div>
        </div>
    </div>
</template>
<script>
    import CommentsContainer from '../CommentsContainer/CommentsContainer.vue'
    import CreateComment from '../CreateComment/CreateComment.vue'
    // import EditModale from '../EditModale/EditModale.vue'
    export default {
        components: {
            // 'edit-modale': EditModale
                  'create-comment':CreateComment,
                  'comments-container': CommentsContainer
        },


        data() {
            return {
                name: 'PostsContainer',
                allPosts: [],
                form:{
                    title:'',
                    content:'',
                    image:''
                },
                selectedFile: '',
                isEditOpen: false,
                isDeleteOpen:false,
                isMyPosts: false,
                currentUserId:'',
                currentUserIsAdmin:false,
                postIndex:null,
                changedIcon: false,

            }
        },
        computed:{
            
            postsToShow(){
                const jwt = require('jsonwebtoken')
                const token = JSON.parse(localStorage.getItem('token'))
                const decodedToken = jwt.verify(token, 'RANDOM_TOKEN_SECRET');
                const userId = decodedToken.userId;
                const myPosts = this.allPosts.filter(post => post.id === userId)
                return this.isMyPosts ? myPosts : this.allPosts
            },
            iconeEdit() {
            const iconeToShow = {
                icon: "fas fa-edit"
            }
            if (this.changedIcon) {
                iconeToShow.icon = "fas fa-times"
            }
            else if(!this.changedIcon)
            {
                iconeToShow.icon = "fas fa-edit"
            }
            return iconeToShow
            },
        },
        created() {
            this.getPosts()
            this.getCurrentUser()
        },
        methods: {
            // récupère l'index de chaque post
            getPostIndex(post){
                this.postIndex= this.postsToShow.findIndex(postToCheck => postToCheck === post)
            },
            // récupère l'id du user connecté
            getCurrentUser(){
                const jwt = require('jsonwebtoken')
                const token = JSON.parse(localStorage.getItem('token'))
                const decodedToken = jwt.verify(token, 'RANDOM_TOKEN_SECRET');
                const userId = decodedToken.userId;
                const isAdmin  = decodedToken.isAdmin
                this.currentUserId = userId
                this.currentUserIsAdmin = isAdmin
            },
            canEdit(post){
                if (post.UserId === this.currentUserId || this.currentUserIsAdmin) {
                    return true
                }else{
                    return false
                }
            },
            getPosts() {
                const axios = require('axios')
                const url = 'http://localhost:3000/api/posts/'
                const token = JSON.parse(localStorage.getItem('token'))
                const config = {
                    headers: {
                        'Authorization': `Bearer ${token}`
                    }
                }
                axios.get(url, config)
                    .then(res => {
                        this.allPosts = res.data.allPosts
                        //console.log();
                        // //console.log(this.allPosts[5]);
                        this.allPosts.reverse()

                    })
            },
            onFileSelected(event) {
                this.form.image = event.target.files[0]
                this.selectedFile = event.target.files[0].name
            },
            formattedDate(post) {
                const postIndex = this.allPosts.findIndex(postIndex => postIndex === post)
                const element = this.allPosts[postIndex].createdAt
                const formattedDate = element.split('T').join((' à '))
                const formattedHour = formattedDate.split(':')
                return formattedHour[0] + 'h' + formattedHour[1]
            },
            editPost(post) {
                this.form.title = post.title
                this.form.content = post.content
                this.form.image = post.image
                this.postIndex = this.postsToShow.findIndex(postToCheck => postToCheck === post)
                this.changedIcon = !this.changedIcon
                this.isEditOpen = !this.isEditOpen
                this.isDeleteOpen = false
            },
            sendEditPost(post){
                const id = post.id
                const axios = require('axios')
                const url = `http://localhost:3000/api/posts/update/${id}`
                const fd = new FormData()
                fd.append('title', this.form.title)
                fd.append('content', this.form.content)

                if (this.selectedFile !== '') {
                    fd.append('image', this.form.image, this.selectedFile)
                }else{
                    fd.append('image',this.form.image)
                }
                const token = JSON.parse(localStorage.getItem('token'))
                
                const config = {
                        headers: {
                            'Authorization': `Bearer ${token}`
                        }
                    }
                    
                axios.put(url,fd,config)
                .then(res => {
                        console.log(res);
                        location.reload()
                    })
                .catch(err => console.log(err))
            },
            deletePost(post) {
                
                this.postIndex = this.postsToShow.findIndex(postToCheck => postToCheck === post)
                this.isDeleteOpen = true
                this.isEditOpen = false
            },
            sendDeletePost(post) {
                const id = post.id
                const axios = require('axios')
                const url = `http://localhost:3000/api/posts/delete/${id}`
                const token = JSON.parse(localStorage.getItem('token'))
                const config = {
                    headers: {
                        'Authorization': `Bearer ${token}`
                    }
                }
                axios.delete(url,config)
                .then(res => {
                    console.log(res);
                    this.isDeleteOpen = false
                    this.isEditOpen = false
                    this.getPosts()
                })
            }
        }
    }
</script>
<style scoped src="./PostsContainer.css">

</style>